option casemap:none

extrn SetWindowsHookExA:proc
extrn UnhookWindowsHookEx:proc
extrn CallNextHookEx:proc
extrn GetMessageA:proc
extrn MessageBoxA:proc
extrn ExitProcess:proc

; 常量定义
WH_KEYBOARD_LL equ 13
HC_ACTION     equ 0
WM_KEYDOWN    equ 0100h
VK_A          equ 41h     ; A键虚拟码

; 结构体定义（字段偏移量）
KBDLLHOOKSTRUCT struct
    vkCode      dword ?   ; +0
    scanCode    dword ?   ; +4
    flags       dword ?   ; +8
    time        dword ?   ; +12
    dwExtraInfo qword ?   ; +16
KBDLLHOOKSTRUCT ends

.data
hHook       dq 0
msg         db 48 dup(0)   ; MSG结构
szTitle     db 'Hook Demo',0
szMessage   db 'A Pressed!',0

.code
main proc
    ; 安装低级键盘钩子
    mov rcx, WH_KEYBOARD_LL
    lea rdx, KeyboardProc
    xor r8, r8
    xor r9, r9
    call SetWindowsHookExA
    mov [hHook], rax

    ; 消息循环
    msg_loop:
    lea rcx, msg
    xor rdx, rdx
    xor r8, r8
    xor r9, r9
    call GetMessageA
    test eax, eax
    jnz msg_loop

    ; 卸载钩子并退出
    mov rcx, [hHook]
    call UnhookWindowsHookEx
    xor rcx, rcx
    call ExitProcess
main endp

KeyboardProc proc frame
    ; 参数：
    ; rcx = nCode
    ; rdx = wParam
    ; r8  = lParam
    push rbp
    .pushreg rbp
    mov rbp, rsp
    sub rsp, 20h
    .allocstack 20h
    .endprolog

    ; 保存原始参数
    mov [rbp - 8], rcx   ; nCode
    mov [rbp - 10h], rdx ; wParam
    mov [rbp - 18h], r8  ; lParam

    ; 检查是否需要处理消息
    cmp ecx, HC_ACTION
    jne forward

    ; 检查按键按下事件
    cmp edx, WM_KEYDOWN
    jne forward

    ; 直接访问结构体字段（vkCode偏移量=0）
    cmp dword ptr [r8 + KBDLLHOOKSTRUCT.vkCode], VK_A
    jne forward

    ; 显示消息框
    xor rcx, rcx
    lea rdx, szMessage
    lea r8, szTitle
    xor r9, r9
    call MessageBoxA

forward:
    ; 调用下一个钩子
    mov rcx, [hHook]
    mov rdx, [rbp - 8]   ; nCode
    mov r8, [rbp - 10h]  ; wParam
    mov r9, [rbp - 18h]  ; lParam
    call CallNextHookEx

    leave
    ret
KeyboardProc endp

end